{$M 16768,180000,180000}
uses goodvga,newmouse,xmsscrll,gamestrc,playgame;

type
     LitLev=record
             x,y,wx,hy: integer;
             name: string[12];
            end;

  const
      RIGHTPCTMAX : byte=5;
      LEFTPCTMAX  : byte=5;
      HelpOutPut  : boolean=true;

     HelpMsg: array[1..28] of string[65]=
('choose previous object                                     ',{1}
 'choose next object                                         ',
 'erase selected object                                      ',
 'save current level to disk (leave demo the same as it was) ',
 'choose finish object                                       ',
 'choose start object                                        ',
 'read more help                                             ',
 'switch to other buttons screen                             ',
 'after this you may select left upper corner in the level   ',
 'after this you may select right down corner in the level   ',{10}
 'turn on/off lines objects output (instead of images)       ',
 '                                                           ',
 'clear all objects from the level                           ',
 '                                                           ',
 'turn on/off background image output if available           ',
 'add objects from file EFILE.LEV to current level           ',
 'save current level to EFILE.LEV file                       ',
 'run game on current level and return to edition then       ',
 'exit from program without saving the level                 ',
 'switch to demo buttons menu (record, play, other)          ',{20}
 'return back to standart buttons menus                      ',
 'record new demo for current level                          ',
 'play current demo for this level if available              ',
 'save level and current demo to disk                        ',
 'the same as play, but very fast                            ',
 'clear current demo and set new demo size to seconds        ',
 'increase seconds field (use right mouse button to start)   ',
 'decrease seconds field (use right mouse button to start)   ');

BUT: array[1..28] of string[20]=
('OBJECT - ', {1}
 'OBJECT + ',
 'DELETE',
 'SAVE',
 'FINISH',
 'START',
 'HELP',
 '**',
 'UP LEFT',
 'DOWN RIGHT',{10}
 'BGOUT',
 'MORE',
 'CLEAR ALL',
 'BGON',
 '',
 'LOAD EFILE',
 'SAVE EFILE',
 'RUN',
 'QUIT',
 'DEMO',      {20}
 'RETURN',
 'RECORD',
 'PLAY',
 'SAVE demo to level',
 'FAST PLAY',
 'CLEAR',
 '>>',
 '<<');       {28}

var
      b: byte;
      CannotSave: boolean;
      BgOut: boolean;
      editlvlobjs: word;
      nl: word;
      SaveNeed,ExitNow: boolean;
      OutMessage: string[80];
      OldExitProc: pointer;
      LevelSave: leveltype;
      DemoPnt: pointer;
      DemoPntSize: word;
      llLVLDemo: pointer;
      CurHelp: byte;
      JustRec: boolean;
      FastPlay: boolean;
      LVLOBJxy: word;
      RetF: word;

      ch : char;

{$F+}
  procedure OurExitProc; far;
 {If the program terminates with a runtime error before the memory         }
 {is deallocated, then the memory will still be allocated, and will be lost}
 {until the next reboot.  This exit procedure is ALWAYS called upon program}
 {termination and will deallocate memory if necessary.                     }
    begin
      ExitProc := OldExitProc; {Chain to next exit procedure}
      TimerOn:=false;
      HaltIsOn:=false;
      repeat until (KEY^.esc=false) or (MouseButton<>0);
      MouseHide;
      Kill_Mouse;
      KillTimer;
      KillKeyBoard;
      InLine($fb);  {STI}
      port[$20]:=$20;
      CloseGoodVga;
      LoadScreen;
      if LVLOBJS<>0 then FreeMem(LEVOBJ,LVLOBJS);
      FreeMem(LEVOBJsaved,sizeof(OBJECTtype)*MAXOBJECTS);
      LVLOBJS:=0;
      WriteLn('Edition done. Returned to text mode.');
      if(RetF<>1) then
      begin
       WriteLn('ERROR: ',errorstring,' ',MouseHnd);
      end;
      FreeAlg;
      halt(1);
    end;

{$F-}

procedure put_up(x,y,x1,y1: integer);
var w: word;
begin
 w:=GetColor;
 SetColor(15);
 line(x+1,y+1,x1-1,y+1);
 line(x+1,y+2,x+1,y1-2);
 SetColor(7);
 line(x+1,y1-1,x1-1,y1-1);
 line(x+2,y1-2,x1-3,y1-2);
 line(x1-1,y+1,x1-1,y1-2);
 line(x1-2,y+2,x1-2,y1-1);
 LoadColor(w);
end;

procedure put_down(x,y,x1,y1: integer);
var w: word;
begin
 w:=GetColor;
 SetColor(7);
 line(x+1,y+1,x1-1,y+1);{}
 line(x+1,y+2,x+1,y1-2);
 SetColor(15);
 line(x+1,y1-1,x1-1,y1-1);{}
 line(x+2,y1-2,x1-3,y1-2);{}
 line(x1-1,y+1,x1-1,y1-2);
 line(x1-2,y+2,x1-2,y1-1);
 LoadColor(w);
end;

procedure OutButton(x,y,w,h: word; bn: byte; up: boolean);
var b: byte;
    s: string;
begin
 s:=BUT[bn];
 b:=TransparentColor;
 SetTransparentColor(0);
 SetBGColor(0);
 if w=0 then w:=Width(s);
 OuttextXy(x+2,y-1,s);
 if h=0 then h:=15;
 if HelpOutPut and MouseInBar(x,y,x+w,y+h) then
  Begin
   if CurHelp<>254 then CurHelp:=bn;
  End;
 if up then Put_Up(x,y,x+w+8,y+h) else Put_Down(x,y,x+w+8,y+h);
 SetTransparentColor(b);
end;

Procedure DeleteLvlObj(w: word);
var w1: word;
begin
 if w=0 then exit;
 if (w=1) and (LevelEnd<>65535) then exit;
 if (ll.LVL.NUM>0) and (w<=ll.LVL.NUM) then
  begin
        SaveNeed:=true;
        dec(ll.LVL.NUM);
        if w<=ll.LVL.NUM then for w1:=w to ll.LVL.NUM do
        begin
          LEVOBJ^[w1]:=LEVOBJ^[w1+1];
          LEVOBJO^[w1]:=LEVOBJO^[w1+1];
        end;
  end;
end;

Procedure Editor;

var CP: byte;
    CO: byte;
    DE: pointer;
    MBwas: byte;
    MR,ML: boolean;
    CurSec: word;
    osh: boolean;
    HelpString: string[80];
    DemoSec: word;
    DemoMsg: string[80];
    EX,EY: integer;
    os,MLP: boolean;
    Mode: byte;
    wbold,wb: word;
    wbx,wby: integer;
    v,rdw,nn: boolean;
    FirstHelp: byte;
    LnOut: boolean;
    w: word;
    ft: file of LitLev;
    fo: LitLev;
    fnd1: boolean;
    fnd: word;
    NoEFile: boolean;
    t,t1: word;
    olev: pointer;
    olevxy: pointer;
    ret: byte;
    LevDemoSize: word;
    DemoRet: string[80];

Procedure PutBar(w: word);
var num,x,y: integer;
begin
  x:=LEVOBJ^[W].x-ex;
  y:=LEVOBJ^[W].y-ey;
  num:=LEVOBJO^[W].num;
  SetColor(15);
  if (x>GetMaxX) or (x+ImageWidth(num)<0) or
     (y>GetMaxY) or (y+ImageHeight(num)<0) then exit;
  line(x,y,x+ImageWidth(num),y);
  line(x+ImageWidth(num),y,x+ImageWidth(num),y+ImageHeight(num));
  line(x,y+ImageHeight(num),x+ImageWidth(num),y+ImageHeight(num));
  line(x,y,x,y+ImageHeight(num));
end;

Procedure EditorDraw(b: boolean);
var w: word;
begin
  if CurHelp<>254 then CurHelp:=255;
  RDW:=false;
  MouseHide;
  if b=false then
   begin
    if (BgImg<>65535) and BgOut then
     begin
       Set_Active_Page(2);
       CopyPage(cp);
     end;

    Set_Active_Page(cp);
    if (BgImg=65535) or (BgOut=false) then cvmpage(cp,ll.LVL.BGCol);

    RightDownCorner(319,Dwn1);
  SetColor(12);
  line(ll.LVL.XF-ex,ll.LVL.YF-ey,ll.LVL.XT-ex,ll.LVL.YF-ey);
  line(ll.LVL.XF-ex,ll.LVL.YT-ey,ll.LVL.XT-ex,ll.LVL.YT-ey);
  line(ll.LVL.XF-ex,ll.LVL.YF-ey,ll.LVL.XF-ex,ll.LVL.YT-ey);
  line(ll.LVL.XT-ex,ll.LVL.YF-ey,ll.LVL.XT-ex,ll.LVL.YT-ey);

  LEVOBJ^[ll.BallObj].x:=ll.LVL.sx;
  LEVOBJ^[ll.BallObj].y:=ll.LVL.sy;

    if ll.LVL.num>0 then
    for w:=0 to ll.LVL.num-1 do
    if LnOut=false then
    putalgimage(LEVOBJ^[W].x-ex,LEVOBJ^[W].y-ey,LEVOBJO^[W].num) else
     begin
      if ImageBorder(LEVOBJO^[W].num) then
       OutBorder(LEVOBJ^[W].x-ex,LEVOBJ^[W].y-ey,LEVOBJO^[W].num) else
       PutBar(W);
     end;

   end;
    RightDownCorner(319,Dwn2);
  SetColor(9);
  if (MODE=0) then
   begin
    OutButton(10,Dwn1+16,0,0,4,not (MouseInBar(10,Dwn1+16,17+width(But[4]),Dwn1+31) and b));
    OutButton(265,Dwn1+16,0,0,5,not (MouseInBar(265,Dwn1+16,272+width(But[5]),Dwn1+31) and b));
    OutButton(215,Dwn1+15,0,0,6,not (MouseInBar(215,Dwn1+15,222+width(But[6]),Dwn1+30) and b));
    OutButton(170,Dwn1+15,0,0,7,not (MouseInBar(170,Dwn1+15,177+width(But[7]),Dwn1+30) and b));
    OutButton(1,Dwn1+1,0,0,1,not (MouseInBar(1,Dwn1+1,8+width(But[1]),Dwn1+16) and b));
    OutButton(170,Dwn1,0,0,2,not (MouseInBar(170,Dwn1,177+width(But[2]),Dwn1+15) and b));
    OutButton(260,Dwn1+1,0,0,3,not (MouseInBar(260,Dwn1+1,267+width(But[3]),Dwn1+16) and b));
   end else if (MODE=1) then
   begin
    OutButton(206,Dwn1+1,0,0,18,not (MouseInBar(206,Dwn1+1,213+width(But[18]),Dwn1+16) and b));
    OutButton(266,Dwn1+1,0,0,20,not (MouseInBar(266,Dwn1+1,273+width(But[20]),Dwn1+16) and b));
    OutButton(240,Dwn1+16,0,0,13,not (MouseInBar(240,Dwn1+16,247+width(But[13]),Dwn1+31) and b));
    OutButton(140,Dwn1+16,0,0,11,not (MouseInBar(140,Dwn1+16,147+width(But[11]),Dwn1+31) and b));
    OutButton(190,Dwn1+16,0,0,14,not (MouseInBar(190,Dwn1+16,197+width(But[14]),Dwn1+31) and b));
    OutButton(1,Dwn1+1,0,0,9,not (MouseInBar(1,Dwn1+1,1+width(But[9]),Dwn1+16) and b));
    OutButton(120,Dwn1+1,0,0,10,not (MouseInBar(120,Dwn1+1,127+width(But[10]),Dwn1+16) and b));
    if (wb<>65532) and (wb<>65531) then SetColor(10) else SetColor(11);
    if (wb<>65532) and (wb<>65531) then OutTextXy(65,Dwn1+1,'<corners>') else
    if wb=65531 then OutTextXy(65,Dwn1+1,'!!!corner>') else
    if wb=65532 then OutTextXy(65,Dwn1+1,'<corner!!!');
    SetColor(9);
   end else if (MODE=2) then
   Begin
    OutButton(1,Dwn1+1,0,0,16,not (MouseInBar(1,Dwn1+1,7+width(But[16]),Dwn1+16) and b));
    OutButton(80,Dwn1+1,0,0,17,not (MouseInBar(80,Dwn1+1,87+width(But[17]),Dwn1+16) and b));
    OutButton(10,Dwn1+16,0,0,19,not (MouseInBar(10,Dwn1+16,17+width(But[19]),Dwn1+31) and b));
    SetColor(4);
    OutTextXy(150,Dwn1+16,OutMessage);
    SetColor(13);
    if SaveNeed then OutTextXy(155,Dwn1+1,'Level not saved!') else
    if ((ll.Lvl.Demo<>nil) and (ll.Lvl.Demo^.Success=false)) then OutTextXy(155,Dwn1+1,'no success demo') else
    if ((ll.Lvl.Demo<>nil) and (ll.Lvl.Demo^.Success)) then
      Begin
       if(cdone>0) then
       Begin
        OutTextXy(155,Dwn1+1,stw(cdone)+' errs in demo');
       End else
       Begin
        OutTextXy(155,Dwn1+1,'Demo very good');
       End;
      End;
    SetColor(9);
   End else if (MODE=3) then
   Begin
    OutButton(10,Dwn1+1,0,0,21,not (MouseInBar(10,Dwn1+1,17+width(But[21]),Dwn1+13) and b));
    OutButton(90,Dwn1+1,0,0,22,not (MouseInBar(90,Dwn1+1,97+width(But[22]),Dwn1+13) and b));
    OutButton(145,Dwn1+1,0,0,23,not (MouseInBar(145,Dwn1+1,152+width(But[23]),Dwn1+13) and b));
    OutButton(185,Dwn1+1,0,0,24,not (MouseInBar(185,Dwn1+1,192+width(But[24]),Dwn1+13) and b));
    OutButton(160,Dwn1+16,0,0,25,not (MouseInBar(160,Dwn1+16,167+width(But[25]),Dwn1+31) and b));
    OutButton(270,Dwn1+16,0,0,26,not (MouseInBar(270,Dwn1+16,277+width(But[26]),Dwn1+31) and b));
    OutButton(52,Dwn1+16,0,0,28,not (MouseInBar(52,Dwn1+16,59+width(But[28]),Dwn1+31) and b));
    OutButton(120,Dwn1+16,0,0,27,not (MouseInBar(120,Dwn1+16,127+width(But[27]),Dwn1+31) and b));
{      BUT22='RECORD';
      BUT23='PLAY';
      BUT24='SAVE';
      BUT25='ADD TEXT';
      BUT26='CLEAR';
      BUT27='>>';
      BUT28='<<';}
    SetColor(13);
    OutTextXy(10,Dwn1+16,'Seconds: ');
    OutTextXy(73,Dwn1+16,stw(DemoSec));

   End;
  if Mode<>3 then
  Begin
   OutButton(240,Dwn1+1,0,13,8,not (MouseInBar(240,Dwn1+1,247+width(But[8]),Dwn1+13) and b));
   SetColor(12);
   OutTextXy(47,Dwn1+16,'X: '+sti(ex));
   OutTextXy(100,Dwn1+16,'Y: '+sti(ey));
   if (MODE=0) then OutTextXy(width(BUT[1])+10,Dwn1+1,':'+stw(word(CO))+'  <>  '+ObjName(co));
  End;
  os:=false;
  SetColor(3);
  if b=false then
   begin
    if OutMessage<>'' then
     OutTextXy(1,Dwn1+27,OutMessage) else
    if CurHelp=254 then
     OutTextXy(1,Dwn1+27,DemoRet) else
    if ((CurHelp<>255) and HelpOutPut) then
    Begin
     OutTextXy(1,Dwn1+27,HelpMsg[CurHelp]);
    End else
    if wb>=65531 then
    OutTextXY(1,Dwn1+27,'Smart game editor by Alexander Larkin. Created on 24/8/98')
    else
     Begin
      if wb<ll.LVL.NUM then
      OutTextXY(1,Dwn1+27,'Selected: '+stw(wb)+'   X: '+
      sti(LEVOBJ^[wb].X)+'   Y: '+sti(LEVOBJ^[wb].Y)+'   Name: '+
      ll.lvlobj[LEVOBJO^[wb].cur].name );
     End;
    Set_Visual_Page(cp);
    cp:=cp xor 1;
   end;
  MouseShow;
  OutMessage:='';
end;

procedure ShowBorder(x,y: integer; num: word);
var i,i1: integer;
    w1,w: word;
begin
    While KeyPressed do ReadKey;
    MouseHide;
    i:=MouseX;
    i1:=MouseY;
    SetPut(24);
    if num<>65535 then if ImageBorder(num) then OutBorder(x,y,num) else
     begin
      line(x,y,x+ImageWidth(num),y);
      line(x+ImageWidth(num),y,x+ImageWidth(num),y+ImageHeight(num));
      line(x,y+ImageHeight(num),x+ImageWidth(num),y+ImageHeight(num));
      line(x,y,x,y+ImageHeight(num));
     end;
    SetPut(0);
    MouseShow;
    nn:=false;
    repeat
     if osh then OutTextXy(1,1,HelpString+'     ');
       if (MouseY<Dwn1) and
          ((MouseX<5) or (MouseY<5) or (MouseX>315) or (MouseY>Dwn1-5)) then
          begin
           if (OS=false) then
           begin
            outtextxy(0,Dwn1+16,'m');
            os:=true;
           end;
          end else
          if os=true then
          begin
           SetColor(8);
           outtextxy(0,Dwn1+16,'m');
           SetColor(3);
           os:=false;
          end;

     MR:=RightButton;
     ML:=LeftButton;
    until (MouseX<>i) or (MouseY<>i1) or ML or MR or KeyPressed or
   ( ((MouseY<=Dwn1) and (MouseButton and 2=2))
     and ((MouseX<5) or (MouseX>315) or (MouseY<5) or (MouseY>Dwn1-5))
   ) or
    ((MouseY>Dwn1) and (MouseButton and 1=1) and RDW);
          if os=true then
          begin
           SetColor(8);
           outtextxy(0,Dwn1+16,'m');
           SetColor(3);
           os:=false;
          end;
    MouseHide;
    SetPut(24);
    if num<>65535 then if ImageBorder(num) then OutBorder(x,y,num) else
     begin
      line(x,y,x+ImageWidth(num),y);
      line(x+ImageWidth(num),y,x+ImageWidth(num),y+ImageHeight(num));
      line(x,y+ImageHeight(num),x+ImageWidth(num),y+ImageHeight(num));
      line(x,y,x,y+ImageHeight(num));
     end;
    SetPut(0);
    MouseShow;
    nn:=false;
end;

procedure OutPutFirstHelp;
begin
  SetColor(12);
  OutTextXY(120,1,'HELP SCREEN');
  SetColor(7);
  OutTextXY(1,12,'Use Scroll Lock key to switch to keyboard mouse control.');
  OutTextXY(1,24,'Usage next keys when the scroll lock light appears:');
  SetColor(10);
  OutTextXy(20,36,'Arrows - move mouse cursor');
  OutTextXy(20,48,'Spacebar - the same as left mouse button');
  OutTextXy(20,60,'Right alt - the same as right mouse button');
  SetColor(9);
  Line(0,80,319,80);
  Line(0,137,319,137);
  Line(0,0,319,0);
  Line(0,165,319,165);
  SetColor(12);
  OutTextXy(30,84,'Usage of mouse buttons when cursor in work area:');
  SetColor(7);
  OutTextXy(15,96,'Left mouse button - put object to the screen.');
  OutTextXy(15,108,'Right mouse button - select object under cursor.');
  OutTextXy(15,120,'Right mouse button on selected object - erase this object.');
  SetColor(12);
  OutTextXy(30,136,'Usage of mouse buttons when cursor in buttons area:');
    SetColor(7);
    OutTextXy(1,148,'Left mouse button - push button under mouse cursor.');
  if Dwn2>210 then
   begin
    OutTextXy(1,165,'Push "MORE" button to read instructions about buttons.');
    OutTextXy(1,177,'I call all buttons in the bottom "buttons screen".');
    OutTextXy(1,189,'Everything upper is the work area.');
  end;
end;

procedure OutPutThirdHelp;
begin
  SetColor(7);
  OutTextXY(1,1,'"CLEAR ALL" - clear everything from current level.');
  OutTextXY(1,12,'"SAVE EFILE" - save current level to EFILE.LEV');
  OutTextXY(1,23,'"LOAD EFILE" - add objects from EFILE.LEV to current level');
  SetColor(12);
  OutTextXY(70,34,'HELP SCREEN (about objects)');
  SetColor(7);
  OutTextXY(1,47,'All information about objects are in DATA.DAT file.');
  OutTextXY(1,58,'You may edit DATA.DAT file with any text editor.');
  OutTextXY(1,69,'Feel free to experient in it.');
  SetColor(12);
  OutTextXY(70,82,'HELP SCREEN (about game)');
  SetColor(7);
  OutTextXY(1,94,'While in "RUN" mode or if you play this game:');
  OutTextXY(1,105,' arrows - move hero');
  OutTextXY(1,116,' r - restart level ;  F1 F2 F9 - screen options');
  OutTextXY(1,127,' a,s,d,w keys when f key pressed - scroll level');
  OutTextXY(1,138,' TAB - go to the next level');
  SetColor(12);
  OutTextXY(1,150,'Current GAME and EDITOR versions are 3.1');
  OutTextXY(1,162,'These game is under construction now.');
  OutTextXY(1,174,'Download latest versions from this address:');
  SetColor(7);
  OutTextXY(1,185,'http://www.geocities.com/SiliconValley/6235/tpdl.htm');
end;

procedure OutPutSecondHelp;
begin
  SetColor(12);
  OutTextXY(70,32,'HELP SCREEN (about "buttons screen")');
  SetColor(7);
  OutTextXY(1,0,'Press right mouse button to scroll the screen when');
  OutTextXY(1,14,'character "m" appears in left down corner of the screen #');
  OutTextXY(1,46,'"OBJECT +" and "OBJECT -":   change current image #');
  OutTextXY(1,57,'"SAVE" - save level and exit from program');
  OutTextXY(1,68,'"QUIT" or ESC  - exit from program without saving #');
  OutTextXY(1,79,'"START" - select start possition for hero.');
  OutTextXY(1,90,'"FINISH" - select possition for finish icon.');
  OutTextXY(1,101,'"**" - switch to the second buttons screen #');
  OutTextXY(1,112,'"DELETE" - delete selected image (object).');
  OutTextXY(1,123,'"RUN" - run current level and return to edition then #');
  OutTextXY(1,134,'"BGOUT" - switch between lines output and images output #');
  OutTextXY(1,145,'"BGON" - switch between background output and no output #');
  OutTextXY(1,156,'"UP LEFT" - select upper left corner of the level area');
  OutTextXY(1,167,'"RIGHT DOWN" - select down right corner of the level area');
  SetColor(9);
  OutTextXY(1,179,'Character # mean that this command (button) do not change');
  OutTextXY(1,190,'anything. Feel free to experient with these buttons.');
end;

procedure ClearLevel;
begin
  FillChar(ll.Lvl,SizeOf(LevelType)-4,0);
  ll.LVL.Header[0]:='L';
  ll.LVL.Header[1]:='V';
  ll.LVL.Header[2]:='L';
  ll.LVL.SX:=160;
  ll.LVL.SY:=0;
  ll.LVL.FX:=50;
  ll.LVL.FY:=0;
  ll.LVL.BgCol:=8;
  ll.LVL.XF:=-200;
  ll.LVL.YF:=-200;
  ll.LVL.XT:=200;
  ll.LVL.YT:=200;
  if LevelEnd<>65535 then
   Begin
    LEVOBJ^[0].x:=ll.LVL.FX;
    LEVOBJ^[0].y:=ll.LVL.FY;
   End;
  ll.LVL.NUM:=ll.BallObj+1;
  SaveNeed:=true;
end;

Procedure AddImage(cur: byte; x,y: integer; num: word);
Begin
     if (ll.Lvl.Num>0) and PutToBuffer(LEVOBJO,LVLOBJOS) then
      begin
       if LVLOBJOS<(ll.LVL.NUM+1)*SizeOf(OTHERtypeOBJ) then
        Begin
         if LVLOBJOS<>0 then freemem(LEVOBJO,LVLOBJOS);
         LVLOBJOS:=LVLOBJOS+sizeof(OTHERtypeOBJ);
         getmem(LEVOBJO,LVLOBJOS);
         GetFromBuffer(LEVOBJO,LVLOBJOS-sizeof(OTHERtypeOBJ));
        End;
       LEVOBJO^[ll.LVL.num].cur:=cur;
       LEVOBJO^[ll.LVL.num].napr:=0;
       LEVOBJO^[ll.LVL.num].UnderMe:=65535;
       LEVOBJO^[ll.LVL.num].UpperMe:=65535;
       LEVOBJO^[ll.LVL.num].Live:=0;
       LEVOBJO^[ll.LVL.num].ManyNum:=0;
       LEVOBJO^[ll.LVL.num].ManyImages:=255;
       LEVOBJO^[ll.LVL.num].num:=num;
       LEVOBJ^[ll.LVL.num].x:=x;
       LEVOBJ^[ll.LVL.num].y:=y;
       Inc(ll.LVL.num);
       SaveNeed:=true;
      end else
      Begin
       TurnOffAutoDecompression;
       SetBufferSize(LVLOBJOS);
       TurnOnAutoDecompression;
      End;
End;

Procedure BeforeBallGame;
Begin
       MouseHide;
       editlvlobjs:=lvlobjos;
       GetMem(olev,EditLVLOBJS);
       move(LEVOBJO^,olev^,editlvlobjs);
       LVLOBJxy:=(LVLOBJOS div sizeof(OTHERtypeOBJ))*sizeof(ObjectType);
       GetMem(olevxy,LVLOBJxy);
       move(LEVOBJ^,olevxy^,LVLOBJxy);

       LevelSave:=ll.LVL;
       nl:=NextLevel;
       Cvm(8);
       SetConstants;
       LoadLVL:=false;
       LoadDate(DatFile,PrevLevel);
       LoadLVL:=true;
       NextLevel:=nl;
End;

Procedure AfterBallGame;
Begin
       repeat until (Key^.ESC=false) or (MouseButton<>0);
       While KeyPressed do ReadKey;
       KeyboardReset;
       ExitNow:=false;
       CurHelp:=254;
       case ret of
        0: DemoRet:='ESC key pressed. Demo interrupted. Demo is not finished.';
        1: DemoRet:='R key pressed (restart level key). Demo is not finished.';
        2: if JustRec then DemoRet:='Demo recorded successful. Try to play it, before saving' else
           DemoRet:='Demo recorded successful. You may save it for game.';
        3: DemoRet:='The hero of the game is dead now. Demo is not finished.';
        4: DemoRet:='The demo work incorrect. Sorry. Try to record it again.';
        5: DemoRet:='Demo overflow.Set more secs, press CLEAR, record again';
        6: DemoRet:='You interrupted demo play by ESC key. Try PLAY again.';
        255: DemoRet:='Thanks for playing this level.';
       end;
       NextLevel:=nl;
       move(olev^,LEVOBJO^,editlvlobjs);
       move(olevxy^,LEVOBJ^,LVLOBJxy);
       FreeMem(olev,editlvlobjs);
       FreeMem(olevxy,LVLOBJxy);
       ll.LVL:=LevelSave;
       Cvm(8);
       SetConstants;
       LoadLVL:=false;
       LoadDate(DatFile,PrevLevel);
       LoadLVL:=true;
       Set_Active_Page(0);
       Set_Visual_Page(0);
       cp:=0;
       MouseShow;
End;

Procedure TestDemoNow(DemoPnt: pointer);
var DemoP: ^DemoType;
Begin
           DemoP:=DemoPnt;
           DemoRet:='Demo is not correct one. Try record again.';
           if(ret=2) then
           Begin
            if(DemoP^.DemoErrors=0) then
            begin
             DemoP^.DemoErrors:=CDone;
            end;
            if(CDone div 50=DemoP^.DemoErrors div 50) then
            Begin
             DemoRet:='The demo for level is OK';
             DemoP^.Success:=true;
            End else
            Begin
             DemoRet:='Demo bad, because '+stw(abs(CDone-DemoP^.DemoErrors) div 50)+' errors in it';
            End;
           End;
End;

begin
 OutMessage:='Here you may find messages';
 SaveNeed:=false;
 osh:=false;
 HelpString:='';
 CurHelp:=255;
 DemoPnt:=nil;
 DemoPntSize:=0;
 ExitNow:=false;
 LnOut:=false;
 FirstHelp:=0;
 RDW:=true;
 Mode:=0;
 CurSec:=1;
 DemoSec:=100;
 DemoMsg:='';
 Set_Visual_Page(1);
 ex:=ll.LVL.SX-160;
 ey:=ll.LVL.SY-100;
 CP:=0;
 CO:=0;
 wb:=65535;
 wbold:=65000;

  Repeat
  mlp:=false;
  EditorDraw(mlp);
  if ML or MR then RDW:=true;
  ml:=false;
  mr:=false;
   Repeat
    if (MouseY<Dwn1+1) and (wb=65533) and (LevelEnd<>65535) then ShowBorder(MouseX,MouseY,LevelEnd) else
    if (MouseY<Dwn1+1) and (wb=65534) then ShowBorder(MouseX,MouseY,MANGOIS[0]) else
    if (MouseY<Dwn1+1) and (wb=65535) then ShowBorder(MouseX,MouseY,ll.LvlObj[co].num) else
    if (MouseY<Dwn1+1) and ((wb=65531) or (wb=65532)) then
     ShowBorder(MouseX,MouseY,65535) else
    if (wb=65531) or (wb=65532) or (wb=65533) or (wb=65534) or (wb=65535) then
     begin
      MR:=RightButton;
      ML:=LeftButton;
     end;
    if wb<65531 then ShowBorder(wbx-ex,wby-ey,LEVOBJO^[wb].num);
    if (MouseButton and 1=1) and (mlp=false) then
     begin
      mlp:=true;
      EditorDraw(mlp);
     end;
   until MR or ML or KeyPressed or
   ( ((MouseY<Dwn1) and (MouseButton and 2=2))
     and ((MouseX<5) or (MouseX>315) or (MouseY<5) or (MouseY>Dwn1-5))
   );

  NN:=false;
  if (MR or (MouseButton and 2=2)) and (MouseY<Dwn1+1) then
   begin
    if mr=false then
     begin
      If MouseX<5 then ex:=ex-50;
      If MouseX>315 then ex:=ex+50;
      If MouseY<5 then ey:=ey-50;
      if MouseY>Dwn1-5 then ey:=ey+50;
     end;
    if (MouseX<5) or (MouseX>315) or (MouseY<5) or (MouseY>Dwn1-5) then NN:=true;
   end;


     if MR and (MouseY<Dwn1+1) and (nn=false) then
     begin
       wbold:=wb;
       wb:=65535;
       if ll.LVL.NUM>0 then
       for w:=0 to ll.LVL.NUM-1 do if ImageBorder(LEVOBJO^[w].num) then
       if ImageCross(MouseX,MouseY,MouseX+400,MouseY+400,
                     LEVOBJ^[w].x-ex,LEVOBJ^[w].y-ey,
                     LEVOBJO^[w].num) mod 2<>0 then
                      Begin
                       wb:=w;
                       OutMessage:='Image '+stw(wb)+' selected.';
                      End;
       if ll.LVL.NUM>0 then
       for w:=0 to ll.LVL.NUM-1 do if (ImageBorder(LEVOBJO^[w].num)=false) and
       (MouseX>LEVOBJ^[w].x-ex) and
       (MouseX<LEVOBJ^[w].x-ex+ImageWidth(LEVOBJO^[w].num)) and
       (MouseY>LEVOBJ^[w].y-ey) and
       (MouseY<LEVOBJ^[w].y-ey+ImageHeight(LEVOBJO^[w].num)) then wb:=w;
       if wbold=wb then
        begin
         DeleteLvlObj(wb);
         wbold:=65000;
         wb:=65535;
        end;
       if wb<65531 then wbx:=LEVOBJ^[wb].x;
       if wb<65531 then wby:=LEVOBJ^[wb].y;
     end;

   if ML and (ll.LVL.num<MaxObjects) and (MouseY<Dwn1+1) and (wb=65535) then
    begin
     AddImage(co,ex+MouseX,ey+MouseY,ll.LvlObj[co].num);
    end;

   if ML and (wb=65534) and (MouseY<Dwn1+1) then
    begin
     ll.LVL.SX:=MouseX+ex;
     ll.LVL.SY:=MouseY+ey;
     SaveNeed:=true;
     wb:=65535;
    end;

   if ML and (wb=65533) and (MouseY<Dwn1+1) then
    begin
     ll.LVL.FX:=MouseX+ex;
     ll.LVL.FY:=MouseY+ey;
     SaveNeed:=true;
     if LevelEnd<>65535 then
      Begin
       LEVOBJ^[0].x:=ll.LVL.FX;
       LEVOBJ^[0].y:=ll.LVL.FY;
      End;
     wb:=65535;
    end;

   if ML and (wb=65532) and (MouseY<Dwn1+1) then
    begin
     ll.LVL.XF:=MouseX+ex;
     ll.LVL.YF:=MouseY+ey;
     if ll.LVL.XF>ll.LVL.XT then ll.LVL.XT:=ll.LVL.XF+100;
     if ll.LVL.YF>ll.LVL.YT then ll.LVL.YT:=ll.LVL.YF+100;
     SaveNeed:=true;
     wb:=65535;
    end;

   if ML and (wb=65531) and (MouseY<Dwn1+1) then
    begin
     ll.LVL.XT:=MouseX+ex;
     ll.LVL.YT:=MouseY+ey;
     if ll.LVL.XF>ll.LVL.XT then ll.LVL.XF:=ll.LVL.XT-100;
     if ll.LVL.YF>ll.LVL.YT then ll.LVL.YF:=ll.LVL.YT-100;
     SaveNeed:=true;
     wb:=65535;
    end;

   if MR or ML then CurHelp:=255;

   if (Mode=0) then
    begin
     if ML and MouseInBar(10,Dwn1+16,17+width(But[4]),Dwn1+31) then
      Begin
         if ll.LVL.Demo<>nil then
         if (SaveNeed or (ll.Lvl.Demo^.Success=false)) then
          Begin
           ll.Lvl.Demo^.Success:=false;
           BeforeBallGame;
           JustRec:=false;
           SetTimerCnst(8192);
           if ll.LVL.Demo<>nil then ret:=BallGame(NextLevel,false,true,ll.LVL.Demo);
           ResetTimerCnst;
           AfterBallGame;
           TestDemoNow(ll.LVL.Demo);
          End;
       if CannotSave=false then
       if not SaveEditorFile(LevelFileName) then CannotSave:=true;
       if CannotSave then
        Begin
         DemoRet:='Cannot save level. Disk full?';
         CurHelp:=254;
        End else SaveNeed:=false;
      End;
     if ML and MouseInBar(170,Dwn1+15,177+width(But[7]),Dwn1+30) then
      begin
      FirstHelp:=0;
       repeat
        MouseHide;
        Set_Active_Page(cp);
        CvmPage(cp,ll.LVL.BGCOL);
        if (FirstHelp=0) then OutPutFirstHelp else
        if (FirstHelp=1) then OutPutSecondHelp else
        OutPutThirdHelp;
        if FirstHelp<2 then BUT[12]:='MORE' else BUT[12]:='DONE';
        FirstHelp:=FirstHelp+1;
        SetColor(3);
        OutTextXY(1,Dwn1+27,'Smart game editor by Alexander Larkin. Created on 24/8/98');
        Set_Visual_Page(cp);
         repeat
          v:=boolean(MouseButton and 1);
          OutButton(130,Dwn1+15,0,0,12,not (MouseInBar(130,Dwn1+15,137+width(But[12]),Dwn1+30) and v));
           MouseShow;
           MBwas:=MouseButton;
           repeat
            ML:=LeftButton;
           until ML or KeyPressed or (MouseButton<>MBwas);
           MouseHide;
         until (ML and MouseInBar(130,Dwn1+15,137+width(But[12]),Dwn1+30)) or
               KeyPressed;
        ml:=false;
        mr:=false;
        cp:=cp xor 1;
        MouseShow;
       until FirstHelp=3;
       FirstHelp:=0;
      end;

     if ML and MouseInBar(1,Dwn1+1,1+width(But[1]),Dwn1+16) then
      Begin
       If CO>0 then dec(co) else if ll.LObj>0 then co:=ll.LObj-1;
       While ll.LvlObj[co].NotEdit do If CO>0 then dec(co) else if ll.LObj>0 then co:=ll.LObj-1;
      End;
     if ML and MouseInBar(265,Dwn1+16,272+width(But[5]),Dwn1+31) then wb:=65533;
     if ML and MouseInBar(215,Dwn1+15,222+width(But[6]),Dwn1+30) then wb:=65534;

     if ML and MouseInBar(170,Dwn1,170+width(But[2]),Dwn1+15) then
     Begin
      if (CO+1<ll.LObj) then inc(co) else co:=0;
      While ll.LvlObj[co].NotEdit do if (CO+1<ll.LObj) then inc(co) else co:=0;
     End;
     if ML and MouseInBar(260,Dwn1+1,260+width(But[3]),Dwn1+16) then if wb<65533 then
      begin
       DeleteLvlObj(wb);
       OutMessage:='Image '+stw(wb)+' deleted.';
       wb:=65535;
      end;
     if ML and MouseInBar(240,Dwn1+1,247+width(But[8]),Dwn1+13) then Mode:=1;
    end else if (Mode=1) then
    begin
     if ML and MouseInBar(240,Dwn1+16,247+width(But[13]),Dwn1+31) then ClearLevel;
     if ML and MouseInBar(140,Dwn1+16,147+width(But[11]),Dwn1+31) then LnOut:=not LnOut;
     if ML and MouseInBar(190,Dwn1+16,197+width(But[14]),Dwn1+31) then
      Begin
       BgOut:=not BgOut;
       if BgImg=65535 then
        Begin
         OutMessage:='Background image not avaliable';
         Mode:=2;
        End;
      End;
     if ML and MouseInBar(240,Dwn1+1,247+width(But[8]),Dwn1+13) then Mode:=2;
     if ML and MouseInBar(1,Dwn1+1,1+width(But[9]),Dwn1+16) then wb:=65532;
     if ML and MouseInBar(120,Dwn1+1,127+width(But[10]),Dwn1+16) then wb:=65531;
     if ML and MouseInBar(266,Dwn1+1,273+width(But[20]),Dwn1+16) then Mode:=3;
     if ML and MouseInBar(206,Dwn1+1,213+width(But[18]),Dwn1+16) then
     if MaxAvail>=(LVLOBJS+sizeof(LevelInfo)+1000) then {run}
      Begin
       BeforeBallGame;
       ret:=BallGame(NextLevel,false,false,de);
       JustRec:=false;
       ret:=255;
       AfterBallGame;
      End else
      Begin
       OutMessage:='Not enough memory to run';
       Mode:=2;
      End;
    end else if (Mode=2) then
     BEgin
      if ML and MouseInBar(1,Dwn1+1,7+width(But[16]),Dwn1+16) then
       Begin
        SaveNeed:=true;
        NoEFile:=false;
        Assign(ft,'efile.lev');
        {$I-}
        Reset(ft);
        {$I+}
        If IoResult<>0 then NoEFile:=true else
         Begin
            Read(ft,fo);
            ll.LVL.FX:=fo.x;
            ll.LVL.FY:=fo.y;
            ll.LVL.SX:=fo.wx;
            ll.LVL.SY:=fo.hy;
            Read(ft,fo);
            ll.LVL.XF:=fo.x;
            ll.LVL.YF:=fo.y;
            ll.LVL.XT:=fo.wx;
            ll.LVL.YT:=fo.hy;
          while not eof(ft) do
           Begin
            Read(ft,fo);
            fnd:=65535;
            if ImageNum>0 then
            for t:=0 to ImageNum-1 do
             if equ(ImageName(t),fo.name) then fnd:=t;

            if fnd=65535 then
            if ImageNum>0 then
            for t:=0 to ImageNum-1 do
             if ((ImageWidth(t)=fo.wx) and
                (ImageHeight(t)=fo.hy)) then fnd:=t;

            if fnd<>65535 then
              Begin
               t:=fnd;
               fnd:=65535;
               fnd1:=false;
               if ll.LObj>0 then
               for t1:=0 to ll.LObj-1 do if fnd1=false then
               if ll.lvlobj[t1].num=t then
                Begin
                 fnd1:=true;
                 AddImage(t1,fo.x,fo.y,ll.lvlobj[t1].num);
                End;
              End;
           End;
          Close(ft);
         End;
       End;
      if ML and MouseInBar(80,Dwn1+1,87+width(But[17]),Dwn1+16) then
       Begin
        Assign(ft,'efile.lev');
        {$I-}
        ReWrite(ft);
        {$I+}
         If IoResult=0 then
          Begin
            fo.x:=ll.LVL.FX;
            fo.y:=ll.LVL.FY;
            fo.wx:=ll.LVL.SX;
            fo.hy:=ll.LVL.SY;
            fo.name:='EFILE.LEV';
            Write(ft,fo);
            fo.x:=ll.LVL.XF;
            fo.y:=ll.LVL.YF;
            fo.wx:=ll.LVL.XT;
            fo.hy:=ll.LVL.YT;
            fo.name:='AVL_SYSTEM';
            Write(ft,fo);
           if ll.LVL.num>0 then
           for w:=0 to ll.LVL.num-1 do
            Begin
             fo.x:=LEVOBJ^[w].x;
             fo.y:=LEVOBJ^[w].y;
             fo.wx:=ll.lvlobj[LEVOBJO^[W].cur].pravo;
             fo.hy:=ll.lvlobj[LEVOBJO^[W].cur].niz;
             fo.name:=ImageName(LEVOBJO^[w].num);
             Write(ft,fo);
            End;
           Close(ft);
          End else
          begin
           ExitNow:=true;
           LevelFileName:='efile.lev';
          End;
       End;
      if ML and MouseInBar(240,Dwn1+1,247+width(But[8]),Dwn1+13) then Mode:=0;
      if ML and MouseInBar(10,Dwn1+16,17+width(But[19]),Dwn1+31) then ExitNow:=true;
     End else
     if Mode=3 then
     Begin
      DemoMsg:='';
      if ML and MouseInBar(10,Dwn1+1,17+width(But[21]),Dwn1+13) then Mode:=1;
      if ML and MouseInBar(52,Dwn1+16,59+width(But[28]),Dwn1+31) then
       Begin
        if DemoSec>CurSec then Dec(DemoSec,CurSec);
        if CurSec<150 then CurSec:=CurSec+3;
       End else
      if ML and MouseInBar(120,Dwn1+16,127+width(But[27]),Dwn1+31) then
       Begin
        if DemoSec<3000-CurSec then Inc(DemoSec,CurSec);
        if CurSec<150 then CurSec:=CurSec+3;
       End else CurSec:=1;
      if MR then CurSec:=1;
      if ML and
       (MouseInBar(145,Dwn1+1,152+width(But[23]),Dwn1+13) or
        MouseInBar(160,Dwn1+16,167+width(But[25]),Dwn1+31)) then {play}
       Begin
        if MouseInBar(160,Dwn1+16,167+width(But[25]),Dwn1+31)
          then FastPlay:=true else FastPlay:=false;
        if ((DemoPnt<>nil) or (ll.LVL.Demo<>nil)) then
         Begin
          if MaxAvail>=(LVLOBJOS+sizeof(LevelInfo)+5000) then {play}
           Begin
            BeforeBallGame;
          LevDemoSize:=DemoSize;
          DemoSize:=DemoPntSize;
          JustRec:=false;
          if FastPlay then SetTimerCnst(8192);
            if DemoPnt<>nil then
             Begin
              ret:=BallGame(NextLevel,false,true,DemoPnt);
              TestDemoNow(DemoPnt);
             End;
          DemoSize:=LevDemoSize;
          if DemoPnt=nil then
            if ll.LVL.Demo<>nil then
            begin
             ret:=BallGame(NextLevel,false,true,ll.LVL.Demo);
             TestDemoNow(DemoPnt);
            end;
            if FastPlay then ResetTimerCnst;
            AfterBallGame;
           End else
           Begin
            OutMessage:='Not enough memory';
            Mode:=2;
           End;
         End else
         Begin
          OutMessage:='No demo in memory';
          Mode:=2;
         End;
       End;
      if ML and MouseInBar(185,Dwn1+1,192+width(But[24]),Dwn1+13) then {save}
       Begin
        if DemoPnt<>nil then
         Begin
          llLVLDemo:=ll.LVL.Demo;
          ll.LVL.Demo:=DemoPnt;
          LevDemoSize:=DemoSize;
          DemoSize:=DemoPntSize;
         End;
        if CannotSave=false then
        if not SaveEditorFile(LevelFileName) then CannotSave:=true;
        if CannotSave then ExitNow:=true else SaveNeed:=false;
        if DemoPnt<>nil then
         Begin
          ll.LVL.Demo:=llLVLDemo;
          DemoSize:=LevDemoSize;
          FreeMem(ll.LVL.Demo,DemoSize+(SizeOf(DemoType)-30000));
          ll.LVL.Demo:=nil;
          DemoSize:=0;
          if MaxAvail>DemoPntSize then
           Begin
            GetMem(ll.LVL.Demo,DemoPntSize+SizeOf(DemoType)-30000);
            DemoSize:=DemoPntSize-(SizeOf(DemoType)-30000);
            Move(DemoPnt^,ll.LVL.Demo^,DemoSize+(SizeOf(DemoType)-30000));
            DemoMsg:='OK, demo updated. Press SAVE to save to disk';
           End else
           Begin
            DemoMsg:='Not enough memory';
           End;
         End else
         Begin
            DemoMsg:='No demo in memory';
         End;
       End;
      if ML and MouseInBar(270,Dwn1+16,277+width(But[26]),Dwn1+31) then {clear}
       Begin
        if DemoPnt<>nil then FreeMem(DemoPnt,DemoPntSize+SizeOf(DemoType)-30000);
        DemoPnt:=nil;
        DemoPntSize:=0;
        if ll.LVL.Demo<>nil then DemoMsg:='Only level demo avaliable now'
         else DemoMsg:='No demo at all now';
       End;
      if ML and MouseInBar(90,Dwn1+1,97+width(But[22]),Dwn1+13) then {record}
       Begin
        if ((DemoPnt<>nil) or (MaxAvail>DemoSec*19+SizeOf(DemoType)-29000)) then
         Begin
          if DemoPnt=nil then
           Begin
            DemoPntSize:=DemoSec*19;
            GetMem(DemoPnt,DemoPntSize+SizeOf(DemoType)-30000);
           End;
          BeforeBallGame;
          LevDemoSize:=DemoSize;
          DemoSize:=DemoPntSize;
          ret:=BallGame(NextLevel,true,false,DemoPnt);
          JustRec:=true;
          DemoSize:=LevDemoSize;
          AfterBallGame;
         End else
         Begin
          OutMessage:='Not enough memory';
          Mode:=2;
         End;
       End;
       if(DemoMsg<>'') then
       Begin
        OutMessage:=DemoMsg;
       End;
     End;

   if ML and (MouseY<Dwn1+1) and (wb<65533) then wb:=65535;
   if (Key^.ESC and ((Mode=0) or (Mode=1)) and SaveNeed) then
    Begin
     mousehide;
     repeat until (Key^.ESC=false) or (MouseButton<>0);
     Mode:=2;
     mouseshow;
    End;
    While KeyPressed do ReadKey;
  Until Key^.ESC or (ExitNow);
 if ll.LVL.NUM>0 then
 for w:=0 to ll.LVL.NUM-1 do LEVOBJO^[w].num:=ll.LvlObj[LEVOBJO^[w].cur].num;
 if DemoPnt<>nil then FreeMem(DemoPnt,DemoPntSize+SizeOf(DemoType)-30000);
 DemoPnt:=nil;
end;

procedure EditHalt;
begin
   WriteLn;
   WriteLn('****************************** EDITOR (begin) *********************');
   WriteLn;
   WriteLn('Usage: EDITOR.EXE filename.DAT [level_number]');
   WriteLn;
   WriteLn('Data file '+DatFile+' not found!');
   WriteLn;
   WriteLn('Example:  EDITOR.EXE DATA.DAT 2');
   WriteLn('          EDITOR.EXE DATA.DAT 0');
   WriteLn;
   WriteLn(' If you have not mouse, then press Scroll Lock key in EDITOR.');
   WriteLn(' Use arrows, SPACEBAR and right Alt instead of mouse then.');
   WriteLn;
   WriteLn('****************************** EDITOR ( end ) *********************');
   WriteLn;
   RetF:=1;
   halt;
end;

begin
RetF:=0;
EditorIs:=true;
OldExitProc := ExitProc;
ExitProc := @OurExitProc;
 DoLevelOff:=true;
 WriteLn;
 WriteLn('This editor created by Alexander Larkin.');
 WriteLn('You may send me any questions to this e-mail address: avlarkin@iname.ru');
 WriteLn;
 WriteLn('Loading... (this may take a minute) ');
 WriteLn;
 LVLobjS:=0;
 CannotSave:=false;
 if ParamCount=0 then
 begin
  DatFile:='data.dat';
  WriteLn('Using default data file data.dat');
  WriteLn('Please, enter level number to edit (key 0 - 3) or ESC for help');
  ch:=ReadKey;
  if((ord(ch)>=48) and (ord(ch)<=57)) then NextLevel:=ord(ch)-48 else EditHalt;
 end else
 begin
  DatFile:=ParamStr(1);
  if ParamCount>1 then NextLevel:=vlw(ParamStr(2)) else NextLevel:=0;
  if NextLevel=65535 then
   begin
    WriteLn('ERROR: Bad level number. Example: EDITOR.EXE 1');
    BigHalt;
   end;
 end;

   if (BGImg=65535) and (RUNBGFILE<>'') then SetIBGPalette;
      InitTimer;
      Init_Mouse;
      SetBar(0,0,319,239);
      MouseShow;
      InitKeyBoard;
      Set_320x240;
      LoadDate(DatFile,NextLevel);
      Editor;
      repeat until (KEY^.esc=false) or (MouseButton<>0);
      MouseHide;
      Kill_Mouse;
      KillTimer;
      KillKeyBoard;
      CloseGoodVga;
      LoadScreen;
      if LVLOBJS<>0 then FreeMem(LEVOBJ,LVLOBJS);
      LVLOBJS:=0;
      WriteLn('Edition done. Returned to text mode.');

 FreeAlg;
 if CannotSave then
  Begin
   WriteLn('ERROR: cannot save level to file '+LevelFileName);
   WriteLn('REASON: disk error. Disk full? Cd-disk? Data lost? Fatal error?');
  End;
 WriteLn;
 WriteLn;
 WriteLn('Thanks for using this editor.');
 halt(0);
end.